import groovy.jface.MetusJFaceBuilder
import de.metus.scripting.*

def tables = this.metus.rootFolder().tablesSub()

jface = new MetusJFaceBuilder()

def shell
shell = jface.shell('Selection', size:[760, 600]){
	migLayout(layoutConstraints:"wrap 4, wmin 10", columnConstraints: "10[90, fill, left, grow, shrink]0[110, fill, left, grow, shrink]10[110, fill, left, grow, shrink]0[110, fill, left, grow, shrink]10", rowConstraints: "[]10[]20[]")
	label("Table 1:")
	combo(id: "table1", style: "READ_ONLY", layoutData:"growx"){
		comboViewer(input: bind(model:tables, modelProperty:"name")){
			selectionChangedListener(){ updateAttr1() }
		}
	}
	label("Table 2:")
	combo(id: "table2", style: "READ_ONLY", layoutData:"growx"){
		comboViewer(input: bind(model:tables, modelProperty:"name")){
			selectionChangedListener(){  updateAttr2() }
		}
	}
	label("Attribute 1:")
	combo(id: "attr1", style: "READ_ONLY", layoutData:"growx"){
	}
	label("Attribute 1:")
	combo(id: "attr2", style: "READ_ONLY", layoutData:"growx"){
	}
	button(id: "delete", style: "CHECK", layoutData: "left", default:false, "Delete existing Connections")
	label("")
	label("")
	label("")
	label("")
	button("OK", default:true){
		onEvent('Selection'){
			if(jface.table1.getText() == ""){
				metus.ui().openError(shell, "No Table chosen!", "\"Table 1\" has not been chosen!")
			}
			else if(jface.table2.getText() == ""){
				metus.ui().openError(shell, "No Table chosen!", "\"Table 2\" has not been chosen!")
			}
			else if(jface.table2.getText() == ""){
				metus.ui().openError(shell, "No Attribute chosen!", "\"Attribute 1\" has not been chosen!")
			}
			else if(jface.table2.getText() == ""){
				metus.ui().openError(shell, "No Attribute chosen!", "\"Attribute 2\" has not been chosen!")
			}
			else{
				execute(shell)
			}
		}
	}
	button("Cancel"){
		onEvent('Selection') { shell.close() }
	}

	label("")
}
updateAttr1()
updateAttr2()
metus.ui().center(shell)
shell.doMainloop()
void updateAttr1(){
	if(jface.table1.getText() == ""){
		jface.attr1.setEnabled(false);
		jface.attr1.removeAll()
	}else{
		jface.attr1.removeAll()
		jface.attr1.setEnabled(true);
		for(def attr: metus.rootFolder().tableSub(jface.table1.getText()).attributes().name){
			jface.attr1.add(attr)
		}
	}
}
void updateAttr2(){
	if(jface.table2.getText() == ""){
		jface.attr2.setEnabled(false);
		jface.attr2.removeAll()
	}else{
		jface.attr2.removeAll()
		jface.attr2.setEnabled(true);
		for(def attr: metus.rootFolder().tableSub(jface.table2.getText()).attributes().name){
			jface.attr2.add(attr)
		}
	}
}
void execute(shell){
	def table1 = jface.table1.getText()
	def table2 = jface.table2.getText()
	def attribute1 = jface.attr1.getText()
	def attribute2 = jface.attr2.getText()
	boolean delete = jface.delete.getSelection()
	def counter = 0
	def connectionsForDelete
	def connectedElements
	if (delete == true){
		for (Element elem1 : metus.rootFolder().tableSub(table1).elements()){
			connectionsForDelete = elem1.connections(table2)
			metus.deleteConnections(connectionsForDelete)
		}
	}
	for (Element elem1 : metus.rootFolder().tableSub(table1).elements()){
		for (Element elem2 : metus.rootFolder().tableSub(table2).elements()){
			if (elem1.get(attribute1).toString().equals(elem2.get(attribute2).toString())){
				connectedElements = elem1.connections(table2)
				if (connectedElements.toString().contains(elem2.toString())){
				}
				else{
					elem1.connect(elem2)
					counter = counter + 1
				}
			}
		}
	}
	console.println("Connections created: " + counter.toString())
	shell.close()
}