import groovy.jface.MetusJFaceBuilder
import de.metus.scripting.*
import de.metus.scripting.Table

import java.util.List

import org.eclipse.swt.widgets.Shell

import de.metus.model.*

List<Table> tables = this.metus.rootFolder().tablesSub()

jface = new MetusJFaceBuilder()
Shell shell
shell = jface.shell('Selection', size:[760, 600]){
	migLayout(layoutConstraints:"wrap 4, wmin 10", columnConstraints: "[90, fill, left, shrink, grow]0[110, fill, left, shrink, grow]10[110, fill, left, shrink, grow]0[110, fill, left, shrink, grow]", rowConstraints: "[top, grow][][bottom, shrink]")
	label("Table 1:")
	combo(id: "table1", style: "READ_ONLY"){
		comboViewer(input: bind(model:tables, modelProperty:"name")){
		}
	}
	label("Table 2:")
	combo(id: "table2", style: "READ_ONLY"){
		comboViewer(input: bind(model:tables, modelProperty:"name")){
		}
	}
	label("Created Table Name:")
	text(id:"newTableName", layoutData:"growx")
	label("")
	label("")
	composite(id: "buttonComposite", layoutData:"span, shrink"){
		migLayout(layoutConstraints:"wrap 2, wmin 10", columnConstraints: "push[25%, fill, shrink, right][25%, fill, shrink, left]push")
		button("OK", default:true, layoutData:"right, shrink"){
			onEvent('Selection'){
				if(jface.table1.getText() == ""){
					metus.ui().openError(shell, "No Table chosen!", "\"Table 1\" has not been chosen!")
				} else if(jface.table2.getText() == ""){
					metus.ui().openError(shell, "No Table chosen!", "\"Table 2\" has not been chosen!")
				} else if(jface.newTableName.getText() == ""){
					metus.ui().openError(shell, "No name provided!", "Please provide a name for the table that will be created!")
				} else if(metus.table(jface.newTableName.getText())){
					metus.ui().openError(shell, "Table already exists!", "A Table with the same name already exists! Please provide a different name for the table that will be created!")
				}
				else{
					execute(shell)
				}
			}
		}

		button("Cancel", layoutData:"left, shrink"){
			onEvent('Selection') { shell.close() }
		}
	}
}

//}
metus.ui().center(shell)
shell.doMainloop()

void execute(shell){
	// CODE VOM NEUEN SCRIPT HIER
	List tableNames = [jface.table1.getText(), jface.table2.getText()];
	int i = 0;
	def Table table = metus.rootFolder().createTable(jface.newTableName.getText());
	console.println("Table " + jface.newTableName.getText() +" has been created!");


	Map<String, List<String>> metusIds = [:];

	for (int a = 0; a < tableNames.size(); a++){
		def elements = metus.rootFolder().tableSub(tableNames[a]).elements();
		for (int b = a; b < tableNames.size(); b++){
			metusIds = [:];
			if(a == b){
				for (int j = 0; j < elements.size(); j++){
					Element source = elements.getAt(j);
					for(Element target : elements.getAt(j).connections(tableNames[b])) {
						if(!metusIds.containsKey(target.id()) || !(metusIds.get(target.id()).contains(source.id()))) {
							Element e = table.createElement(i.toString());
							e.connect(elements.getAt(j));
							e.connect(elements.findAll{it.id()==target.id()});

							List<String> targetIds = []
							if(metusIds.containsKey(target.id())) {
								targetIds = metusIds.get(target.id())
							}
							targetIds.add(source.id())
							metusIds.put(target.id(), targetIds)


							List<String> sourceIds = []
							if(metusIds.containsKey(source.id())){
								sourceIds = metusIds.get(source.id())
							}
							sourceIds.add(target.id())
							metusIds.put(source.id(), sourceIds)

							i++;
						}
					}
				}

			} else {
				for (int l = 0; l < elements.size(); l++){
					Element source = elements.getAt(l);
					def elements2 = metus.rootFolder().tableSub(tableNames[b]).elements();
					for(Element target : elements.getAt(l).connections(tableNames[b])) {
						if(!metusIds.containsKey(target.id()) || !(metusIds.get(target.id()).contains(source.id()))) {
							Element e = table.createElement(i.toString());
							e.connect(elements.getAt(l));
							e.connect(elements2.findAll{it.id()==target.id()});

							List<String> targetIds = []
							if(metusIds.containsKey(target.id())) {
								targetIds = metusIds.get(target.id())
							}
							targetIds.add(source.id())
							metusIds.put(target.id(), targetIds)


							List<String> sourceIds = []
							if(metusIds.containsKey(source.id())){
								sourceIds = metusIds.get(source.id())
							}
							sourceIds.add(target.id())
							metusIds.put(source.id(), sourceIds)

							i++;
						}
					}
				}
			}

		}
	}

	shell.close()
}