import groovy.jface.MetusJFaceBuilder
import de.metus.scripting.*

def tables = this.metus.rootFolder().tablesSub()

jface = new MetusJFaceBuilder()

def shell
shell = jface.shell('Selection', size:[760, 600]){
	migLayout(layoutConstraints:"wrap 1", columnConstraints: "[grow, shrink]", rowConstraints: "[grow, shrink]10[grow, shrink]")

	composite(id:'composite1', layoutData:"grow, shrink, wmin 10"){

		migLayout(layoutConstraints:"wrap 2", columnConstraints: "10[fill]5[fill, grow, shrink, 150]10", rowConstraints: "[]10[]5[]5[]")

		label("Select Tables for: ")
		label("")

		label("Variant Products:")
		combo(id: "table1", style: "READ_ONLY"){
			comboViewer(input: bind(model:tables, modelProperty:"name")){
			}
		}

		label("Feature Values:")
		combo(id: "table2", style: "READ_ONLY"){
			comboViewer(input: bind(model:tables, modelProperty:"name")){
			}
		}

		label("Variant Components:")
		combo(id: "table3", style: "READ_ONLY"){
			comboViewer(input: bind(model:tables, modelProperty:"name")){
			}
		}
	}

	composite(id: "buttons", layoutData: "wmin 10, shrink, grow"){
		migLayout(layoutConstraints:"wrap 4", columnConstraints: "[25%, fill, grow, shrink][25%, fill, grow, shrink][25%, fill, grow, shrink][25%, fill, grow, shrink]", rowConstraints: "")

		label("")

		button("OK", default:true){
			onEvent('Selection'){
				if(jface.table1.getText() == ""){
					metus.ui().openError(shell, "No Table chosen!", "\"Variant Products\" Table has not been chosen!")
				}
				else if(jface.table2.getText() == ""){
					metus.ui().openError(shell, "No Table chosen!", "\"Feature Values\" Table has not been chosen!")
				}
				else if(jface.table3.getText() == "" ){
					metus.ui().openError(shell,  "No Table chosen!", "\"Variant Components\" Table has not been chosen!")
				}
				else{
					execute(shell)
				}
			}
		}

		button("Cancel"){
			onEvent('Selection') { shell.close() }
		}

		label("")
	}
}
metus.ui().center(shell)
shell.doMainloop()

void execute(shell){
	def connectedVarProductVarValue
	def connectedVarComponentVarValue
	def checkIfAllValues
	def connectedVarSystemVarValues
	def table1 = jface.table1.getText()
	def table2 = jface.table2.getText()
	def table3 = jface.table3.getText()

	for (Element product : metus.rootFolder().tableSub(table1).elements()){
		connectedVarProductVarValue = []
		connectedVarProductVarValue = product.connections(table2)
		for (Element component : metus.rootFolder().tableSub(table3).elements()){
			connectedVarComponentVarValue = component.connections(table2)
			checkIfAllValues = connectedVarComponentVarValue.minus(connectedVarProductVarValue)
			if (checkIfAllValues == []){
				component.connect(product)
				console.println("Connection Made between " + component + " and " + product)
			}
		}
	}
	// TODO: wird evtl noch bentigt, wenn nicht vor release lschen
	// for table2
	/* for (Element system : metus.rootFolder().tableSub(table2).elements()){
	 connectedVarSystemVarValue = []
	 connectedVarSystemVarValue = system.connections(selectionValue)
	 for (Element component : metus.rootFolder().tableSub("Var_Component_Zielloesungen").elements()){
	 connectedVarComponentVarValue = component.connections(selectionValue)
	 checkIfAllValues = connectedVarComponentVarValue.minus(connectedVarSystemVarValue)
	 if (checkIfAllValues == []){
	 component.connect(system)
	 }
	 }
	 } */
	shell.close()
}
