import groovy.jface.MetusJFaceBuilder
import de.metus.scripting.*
import org.eclipse.swt.widgets.Display
import org.eclipse.swt.graphics.Color

def tables = this.metus.rootFolder().tablesSub()

jface = new MetusJFaceBuilder()

def shell
shell = jface.shell('Selection'){
	migLayout(layoutConstraints:"wrap 1, wmin 10", columnConstraints: "[grow, shrink]", rowConstraints: "[]5[]")

	composite(id: "comboMenus", layoutData: "grow, shrink, wmin 10"){
		migLayout(layoutConstraints:"wrap 2", columnConstraints: "[left, grow, shrink, fill, 25%][75%, left, fill, grow, shrink]", rowConstraints: "[grow, shrink][grow, shrink][grow, shrink][grow, shrink][grow, shrink][grow, shrink][grow, shrink]")


		label(id:"a", "Select tables for indirect connections:", layoutData:"span 2")
		
		label("(leave values empty if you do not need them)", layoutData:"span 2")


		label("Start table:")
		combo(id: "starttable", style: "READ_ONLY, BORDER"){
			comboViewer(input: bind(model:tables, modelProperty:"name")){
			}
		}

		label("Table 1:")
		combo(id: "table1", style: "READ_ONLY"){
			comboViewer(input: bind(model:tables, modelProperty:"name")){
			}
		}

		label("Table 2:")
		combo(id: "table2", style: "READ_ONLY"){
			comboViewer(input: bind(model:tables, modelProperty:"name")){
			}
		}

		label("Table 3:")
		combo(id: "table3", style: "READ_ONLY"){
			comboViewer(input: bind(model:tables, modelProperty:"name")){
			}
		}

		label("End table:")
		combo(id: "endtable", style: "READ_ONLY"){
			comboViewer(input: bind(model:tables, modelProperty:"name")){
			}
		}
	}

	composite(id: "buttonGroup", layoutData: "grow, shrink"){
		migLayout(layoutConstraints:"wrap 4", columnConstraints: "[grow, shrink][fill, right, grow, shrink, 50]10[fill, right, grow, shrink, 50][grow, shrink]", rowConstraints: "15[grow, shrink]")

		label("")

		button("OK", default:true, layoutData:"right"){
			onEvent('Selection'){ execute(shell) }
		}

		button("Cancel", layoutData:"right"){
			onEvent('Selection') { shell.close() }
		}

		label("")
	}
}

metus.ui().center(shell)
shell.doMainloop()

void execute(shell){

	def final FROM = jface.starttable.getText()
	def final VIA1 = jface.table1.getText()
	def final VIA2 = jface.table2.getText()
	def final VIA3 = jface.table3.getText()
	def final TO = jface.endtable.getText()
	def indirectConnections
	def directConnections
	def directConnectionsForDelete

	if (FROM == "" || TO == ""){
		metus.ui.openInformation(null, "Please select a Start and End Table", "Select a Start and an End Table to execute the Script");
	} else if (VIA1 == "" && VIA2 == "" && VIA3 == ""){
		metus.ui.openInformation(null, "Please select a Table", "Select at least one Table to execute the Script");
	}else{


		Table fromTable = metus.rootFolder().tableSub(FROM)
		Table via1Table = metus.rootFolder().tableSub(VIA1)
		Table via2Table = metus.rootFolder().tableSub(VIA2)
		Table via3Table = metus.rootFolder().tableSub(VIA3)
		Table toTable	= metus.rootFolder().tableSub(TO)


		for (Element elem : fromTable.elements()){
			directConnections = elem.connections(toTable)
			if (via1Table == null){
				if (via2Table == null){
					indirectConnections = elem.connections(via3Table).flatten()*.connections(toTable).flatten().unique()
				} else {
					if (via3Table == null){
						indirectConnections = elem.connections(via2Table).flatten()*.connections(toTable).flatten().unique()
					} else {
						indirectConnections = elem.connection(via2Table).connections(via3Table).flatten()*.connections(toTable).flatten().unique()
					}
				}
			} else {
				if (via2Table == null){
					if (via3Table == null){
						indirectConnections = elem.connections(via1Table).flatten()*.connections(toTable).flatten().unique()
					} else {
						indirectConnections = elem.connections(via1Table).connections(via3Table).flatten()*.connections(toTable).flatten().unique()
					}
				} else {
					if (via3Table == null){
						indirectConnections = elem.connections(via1Table).connections(via2Table).flatten()*.connections(toTable).flatten().unique()
					} else {
						indirectConnections = elem.connections(via1Table).connections(via2Table).connections(via3Table).flatten()*.connections(toTable).flatten().unique()
					}
				}
			}
			directConnectionsForDelete = directConnections.minus(indirectConnections)
			metus.deleteConnections(directConnectionsForDelete)
			indirectConnections.minus(directConnections)*.connect(elem)
			// console.println(indirectConnections.toString() + " " + directConnections.toString() + "  " + elem.toString())
		}

		shell.close()
	}
}